﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {

        public byte[] BufferOut = new byte[50];
        public byte[] BufferIn = new byte[100];
        public byte[] Rele = new byte[5];
        public Int32 AinPP = 0;
        public Int32 AinPM = 32768;
        public bool Offset = false;
        public bool Gain = false;
        public double temp = 0;
        public Int16 tempInt = 0;
        public bool SendConfig = false;
        public bool write = false;
        public bool Init = false;
        

                public Form1()
        {
            InitializeComponent();
            UpdateCOMPortList();
           
        }

                private void UpdateCOMPortList()
                {
                    int i;
                    bool foundDifference;

                    i = 0;
                    foundDifference = false;

                    //If the number of COM ports is different than the last time we
                    //  checked, then we know that the COM ports have changed and we
                    //  don't need to verify each entry.
                    if (lstCOMPorts.Items.Count == SerialPort.GetPortNames().Length)
                    {
                        //Search the entire SerialPort object.  Look at COM port name
                        //  returned and see if it already exists in the list.
                        foreach (string s in SerialPort.GetPortNames())
                        {
                            //If any of the names have changed then we need to update 
                            //  the list
                            if (lstCOMPorts.Items[i++].Equals(s) == false)
                            {
                                foundDifference = true;
                            }
                        }
                    }
                    else
                    {
                        foundDifference = true;
                    }

                    //If nothing has changed, exit the function.
                    if (foundDifference == false)
                    {
                        return;
                    }

                    //If something has changed, then clear the list
                    lstCOMPorts.Items.Clear();

                    //Add all of the current COM ports to the list
                    foreach (string s in SerialPort.GetPortNames())
                    {
                        lstCOMPorts.Items.Add(s);
                    }
                    //Set the listbox to point to the first entry in the list
                    lstCOMPorts.SelectedIndex = 0;
                }

        private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) // Close if port open
                serialPort1.Close();

            serialPort1.PortName = lstCOMPorts.Text;
            serialPort1.Open(); // Open Com port
            if (serialPort1.IsOpen)
            {
                //textBox1.Text = "OK";
                serialPort1.DiscardInBuffer(); // Clean buffer
                MessageBox.Show("OK!");
                timer1.Enabled = true;

                ReadConfig();

                write = true;
                WriteModbus();
            }
            else timer1.Enabled=false;

        }

        private void ReadConfig()
    {
        serialPort1.DiscardInBuffer(); // Clean buffer

         //Modbus Read Function Framework , Header
        BufferOut[0] = 1; //address
        BufferOut[1] = 4; // Function Code
        BufferOut[2] = 0; // Start Address High
        BufferOut[3] = 13; //Start Address Low
        BufferOut[4] = 0; //Number of registers High
        BufferOut[5] = 1; //Number of registers Low

        serialPort1.Write(BufferOut, 0, 6); // Send 6 bytes

        System.Threading.Thread.Sleep(20);

        serialPort1.Read(BufferIn, 0, 9); // Receive 9 Bytes, Last 2 Bytes are CRC no need to check

        //Ext2
        if ((BufferIn[3] & 1) > 0)
            comboBox1.SelectedIndex = 0;
        else
            comboBox1.SelectedIndex = 1;

        //Ext3
        if ((BufferIn[3] & 2) > 0)
            comboBox2.SelectedIndex = 0;
        else
            comboBox2.SelectedIndex = 1;

        //Ext3
        if ((BufferIn[3] & 4) > 0)
            comboBox3.SelectedIndex = 0;
        else
            comboBox3.SelectedIndex = 1;

        //PWM
        if ((BufferIn[3] & 8) > 0)
            comboBox2.SelectedIndex = 2;

        //ICP
        if ((BufferIn[3] & 16) > 0)
            comboBox1.SelectedIndex = 2;


    }

        private void WriteConfig()

        {
            if (SendConfig == false)
                return;

            SendConfig = false;

            serialPort1.DiscardInBuffer(); // Clean buffer

            //Modbus Read Function Framework , Header
            BufferOut[0] = 1; //address
            BufferOut[1] = 6; // Function Code
            BufferOut[2] = 0; // Start Address High
            BufferOut[3] = 13; //Start Address Low
            BufferOut[4] = 0; //1º register high
            BufferOut[5] = 0; //1º register Low
                              

            //Ext2
            switch (comboBox1.SelectedIndex)
            {
                case 0:
                BufferOut[4] = 1;
                break;

                case 1:
                BufferOut[4] = 0;
                break;

                case 2:
                BufferOut[4] = 1 + 16; //ICP
                break;

            }


            //Ext3
            switch (comboBox2.SelectedIndex)
            {
                case 0:
                    BufferOut[4] =  Convert.ToByte(BufferOut[4] + 2);
                    break;

                case 1:
                    BufferOut[4] = Convert.ToByte(BufferOut[4] + 0);
                    break;

                case 2:
                    BufferOut[4] = Convert.ToByte(BufferOut[4] + 8);
                    break;

            }

            //Ext4
            if (comboBox3.SelectedIndex == 0)
                BufferOut[4] = Convert.ToByte(BufferOut[4] + 4);
            else
                BufferOut[4] = Convert.ToByte(BufferOut[4] + 0);

           

            serialPort1.Write(BufferOut, 0, 6); // Send 6 bytes

            System.Threading.Thread.Sleep(20);

            MessageBox.Show("Ok!");

                }


        private void WriteModbus()
        {
            if (write == false)
                return;

            write = false;

            serialPort1.DiscardInBuffer(); // Clean buffer

            //Modbus Write Function Framework , Header
            BufferOut[0] = 1; //address
            BufferOut[1] = 16; // Function Code
            BufferOut[2] = 0; // Start Address High
            BufferOut[3] = 7; //Start Address Low
            BufferOut[4] = 0; //nº of reg High
            BufferOut[5] = 3; //nº of reg low
            BufferOut[6] = 6; //Byte count

           
            //Ext2
            BufferOut[8] = 0;
            if (checkBox1.Checked)
                BufferOut[8] = 1;


            //Ext3
            BufferOut[10] = 0;
            if (checkBox2.Checked)
                BufferOut[10] = 1;

            //Ext4
            BufferOut[12] = 0;
            if (checkBox3.Checked)
                BufferOut[12] = 1;

            serialPort1.Write(BufferOut, 0, 13); // Send 13 bytes

            System.Threading.Thread.Sleep(20);
            
            //Write PWM

            //Modbus Write Function Framework , Header
            BufferOut[0] = 1; //address
            BufferOut[1] = 16; // Function Code
            BufferOut[2] = 0; // Start Address High
            BufferOut[3] = 12; //Start Address Low
            BufferOut[4] = 0; //nº of reg High
            BufferOut[5] = 1; //nº of reg low
            BufferOut[6] = 2; //Byte count

            //PWM
            tempInt = Convert.ToInt16(trackBar1.Value);
            BufferOut[7] = Convert.ToByte(tempInt>>8);
            BufferOut[8] = Convert.ToByte(tempInt & 255);

            serialPort1.Write(BufferOut, 0, 9); // Send 9 bytes

            System.Threading.Thread.Sleep(20);


            //Zero Counter e Freq
            if (Init == true) return;

            Init = true;

            //Modbus Write Function Framework , Header
            BufferOut[0] = 1; //address
            BufferOut[1] = 16; // Function Code
            BufferOut[2] = 0; // Start Address High
            BufferOut[3] = 10; //Start Address Low
            BufferOut[4] = 0; //nº of reg High
            BufferOut[5] = 2; //nº of reg low
            BufferOut[6] = 4; //Byte count

            //Freq
            BufferOut[7] = 0;
            BufferOut[8] = 0;

            //Counter
            BufferOut[9] = 0;
            BufferOut[10] = 0;

            serialPort1.Write(BufferOut, 0, 11); // Send 9 bytes

            System.Threading.Thread.Sleep(20);

          }



        private void ReadModbus()
    {

        if (!serialPort1.IsOpen) return;

       
        //Modbus Read Function Framework , Header
        BufferOut[0] = 1; //address
        BufferOut[1] = 4; // Function Code
        BufferOut[2] = 0; // Start Address High
        BufferOut[3] = 0; //Start Address Low
        BufferOut[4] = 0; //Number of registers High
        BufferOut[5] = 12; //Number of registers Low

        serialPort1.Write(BufferOut, 0, 6); // Send 6 bytes

        System.Threading.Thread.Sleep(100);

        serialPort1.Read(BufferIn, 0, 31); // Receive 31 Bytes, Last 2 Bytes are CRC no need to check

        // Ain0    
        Array.Reverse(BufferIn, 3, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 3);
        temp = Convert.ToDouble(tempInt / 1573.85);
        if (comboBox5.SelectedIndex == 1)
            temp = temp / 0.27;
        textBox2.Text = Convert.ToString(Math.Round(temp, 5));

        // Ain1
        Array.Reverse(BufferIn, 5, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 5); 
        temp = Convert.ToDouble(tempInt / 1573.85);
        textBox1.Text = Convert.ToString(Math.Round(temp, 5));

        // Ain2
        Array.Reverse(BufferIn, 7, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 7); 
        temp = Convert.ToDouble(tempInt / 1573.85);
        if (comboBox7.SelectedIndex == 1)
            temp = temp / 0.27;
        textBox3.Text = Convert.ToString(Math.Round(temp, 5));

        // Ain3
        Array.Reverse(BufferIn, 9, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 9); 
        temp = Convert.ToDouble(tempInt / 1573.85);
        if (comboBox6.SelectedIndex == 1)
            temp = temp /0.27;
        textBox4.Text = Convert.ToString(Math.Round(temp, 5));

        // Ain4
        Array.Reverse(BufferIn, 11, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 11); 
        temp = Convert.ToDouble(tempInt / 1573.85);
        textBox5.Text = Convert.ToString(Math.Round(temp, 5));


        // Ain5
        Array.Reverse(BufferIn, 13, 2); // Little Endian
        tempInt = BitConverter.ToInt16(BufferIn, 13);
        temp = Convert.ToDouble(tempInt / 1573.85);
        if (comboBox8.SelectedIndex == 1)
            temp = temp /0.27;
        textBox6.Text = Convert.ToString(Math.Round(temp, 5));

        // Temp
        temp = Convert.ToDouble(BufferIn[15] * 256 + BufferIn[16]);
        label13.Text = Convert.ToString(Math.Round(temp/10, 2)) + " ºC";

        //Ext1
        if (BufferIn[18] >= 1)
        {
            textBox9.BackColor = Color.Green;
            textBox9.Text="ON";
        }
        else
        {
            textBox9.BackColor = Color.Red;
            textBox9.Text = "OFF";
        }

        //Ext2
        if (BufferIn[20] >= 1)
        {
            textBox10.BackColor = Color.Green;
            textBox10.Text = "ON";
        }
        else
        {
            textBox10.BackColor = Color.Red;
            textBox10.Text = "OFF";
        }

        //Ext3
        if (BufferIn[22] >= 1)
        {
            textBox11.BackColor = Color.Green;
            textBox11.Text = "ON";
        }
        else
        {
            textBox11.BackColor = Color.Red;
            textBox11.Text = "OFF";
        }

        // Freq
        textBox7.Text = Convert.ToString(BufferIn[23] * 256 + BufferIn[24]);

        // Counter
        textBox8.Text = Convert.ToString(BufferIn[25] * 256 + BufferIn[26]);

      
       }

        
        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox4.SelectedIndex = 0;
            comboBox9.SelectedIndex = 0;

            comboBox5.SelectedIndex = 0;
            comboBox6.SelectedIndex = 0;
            comboBox7.SelectedIndex = 0;
            comboBox8.SelectedIndex = 0;

            
        }

       

        private void timer1_Tick(object sender, EventArgs e)
        {

              if (!serialPort1.IsOpen)
                return;

             // clean buffer
             serialPort1.Read(BufferIn,0,serialPort1.BytesToRead); 

            //Read   
            ReadModbus();

            //Write Config
            WriteConfig();
            
            //Write Modbus
            WriteModbus();
           
        }

               

        private void timer2_Tick(object sender, EventArgs e)
        {
            UpdateCOMPortList();
        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            AinPP = 0;
            AinPM = 32768;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) // Close if port open
                serialPort1.Close();

            Init = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Offset = true;
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            SendConfig = true;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            write = true;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            write = true;
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            write = true;
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            write = true;
        }

        

       

    }
}